#pragma once
#include "AutoTextListCtrl.h"
#include "AutoTextRichEditCtrl.h"

class CAutoTextConfigDlg : public CDialog
{
	struct SORTPARAM
	{
		int nSortColumn;
		bool bSortAscending;
		CAutoTextListCtrl *pList;
	};

	DECLARE_DYNAMIC(CAutoTextConfigDlg)

public:
	CAutoTextConfigDlg(CWnd* pParent = NULL);   // ǥ Դϴ.
	virtual ~CAutoTextConfigDlg();
	void CloseDlg();

	enum { IDD = IDD_AUTOTEXT_DLG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV Դϴ.
	virtual BOOL OnInitDialog();

	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnLvnItemchangedList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnHdnItemclickList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnEnSetfocusEditContent();
	afx_msg void OnEnKillfocusEditContent();

	DECLARE_MESSAGE_MAP()

private:
	static int CALLBACK SortFunc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort);
	static int ComboIndexToVectorIndex(int nComboIndex);
	static int VectorIndexToComboIndex(int nVectorIndex);

	void SetSkin();
	void __ResourceLoad(BOOL bInit);
	void ReSizeCtrl();
	void InitListColumn(CAutoTextListCtrl &list, CStringArray &strHeaderTitle, const int *arrWidth);
	void InitListCtrl();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	bool IsCloseMsg(MSG* pMsg);
	void InitComboBox();
	void InitRichedit();
	void LoadAutoTextToList();
	void OnBnClickedAdd();
	void OnBnClickedSave();
	void OnBnClickedDelete();
	bool IsExistVectorIndex(int nShortKey);
	void UpdateAutoTextWithShortKey(int nShortKey, CString strContent);
	void InsertAutoTextToNoShortKey(int nShortKey, CString strContent);
	void RefreshButtonState();
	void DeleteAutoText(int nVectorIndex);
	CString GetShortKeyString(int nVectorIndex);
	int GetSelectedItemIndex();
	void SortList(int nSortColumn);
	void UnSelectAll();

	CButton m_btnAdd;
	CButton m_btnSave;
	CButton m_btnDelete;
	CAutoTextListCtrl m_listAutotext;
	CNMImgComboBox	m_comboShortkey;
	
	CAutoTextRichEditCtrl	m_editContent;
	CHARFORMAT2		m_cfContentInput;
	CHARFORMAT2		m_cfContentDefault;
	PARAFORMAT2		m_pfContent;

	CPen	m_penBorder;

	int		m_nOriginalVectorIndex;
	CString m_strOriginalContent;
	bool	m_bSortAscending;
};
